// Functions for easy use of HD44780 LCD display on Kamami KAMeLeon STM32L496 board.
// jk 12'2017

#ifndef	_KAMAMI_L496_LCD_H
#define	_KAMAMI_L496_LCD_H
#include <stdint.h>

/* Initialize HD44780 2x16 LCD display. 
 * The function should be called before using any other LCD display function. 
 * It initializes GPIO lines and performs HD44780 initialization sequence. */
void lcd_init(void);

/* Turn on LDC backlight. */ 
void lcd_backlight_on (void);

/* Turn off LDC backlight. */ 
void lcd_backlight_off (void);

/* Clear the LCD display. */ 
void lcd_clear(void);

/* Display a character string of a given length on the LCD display. 
 * The string is displayed in a given row, starting from a given column.
 * @param data: string to display
 * @param len:  length of the string to display
 * @param row:  row to display string in - can be 1 - first row - or 2 - second row
 * @param col:  column to put the first character of the string in - can be 1-16
 */
void lcd_display(char *data, uint8_t len, uint8_t row, uint8_t col);

#endif
