// Functions for easy use of potentiometer on Kamami KAMeLeon STM32L496 board.
// jk 11'2017

#ifndef	_KAMAMI_L496_POT_H
#define	_KAMAMI_L496_POT_H
#include <stdint.h>

/* Initialize potentiometer. 
 * The function should be called before using any other potentiometer function. 
 * It initializes GPIO line and ADC (ADC3 is used for potentiometer). */
void pot_init(void);

/* Get the value read from potentiometer as a 12-bit number.
 * The function is blocking. It starts the measurement and waits for it to end.
 * @retval Potentiometer value in the range 0-0xfff. */
uint16_t pot_read(void);

#endif
